/*
 * ________________________________________________________________________________________________________
 * Copyright (c) 2016-2016 InvenSense Inc. All rights reserved.
 *
 * This software, related documentation and any modifications thereto (collectively Software) is subject
 * to InvenSense and its licensors' intellectual property rights under U.S. and international copyright
 * and other intellectual property rights laws.
 *
 * InvenSense and its licensors retain all intellectual property and proprietary rights in and to the Software
 * and any use, reproduction, disclosure or distribution of the Software without an express license agreement
 * from InvenSense is strictly prohibited.
 *
 * EXCEPT AS OTHERWISE PROVIDED IN A LICENSE AGREEMENT BETWEEN THE PARTIES, THE SOFTWARE IS
 * PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * EXCEPT AS OTHERWISE PROVIDED IN A LICENSE AGREEMENT BETWEEN THE PARTIES, IN NO EVENT SHALL
 * INVENSENSE BE LIABLE FOR ANY DIRECT, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 * OF THE SOFTWARE.
 * ________________________________________________________________________________________________________
 */

/* board driver */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "i2c_interface.h"

#include "i2c.h"
#include "nrf_log.h"

/* I2C slave address for INV device */
#define ICM_I2C_ADDR 0x68

/* I2C address for Ak09915 */
#define AK_I2C_ADDR 0x0E

int inv_io_hal_read_reg(struct inv_icm406xx_serif * serif, uint8_t reg, uint8_t *rbuffer, uint32_t rlen)
{
    if(rlen > 256)
    {
        NRF_LOG_INFO("icm40608 i2c read data too leng\r\n");
        return -1;
    }
    I2c_Write(ICM_I2C_ADDR, &reg, 1, true);
    I2c_Read(ICM_I2C_ADDR, rbuffer, rlen);
    return 0;
}

int inv_io_hal_write_reg(struct inv_icm406xx_serif * serif, uint8_t reg, const uint8_t *wbuffer, uint32_t wlen)
{
    uint8_t w2_data[256];

    if(wlen > 255)
    {
        NRF_LOG_INFO("icm40608 i2c write data too leng\r\n");
        return -1;
    }
    w2_data[0] = reg;
    memcpy(&w2_data[1], wbuffer, wlen);
    
    I2c_Write(ICM_I2C_ADDR, w2_data, wlen+1, false);
    return 0;
}
